# Tutorial

:project Tutoriel: Premier projet

## Fenêtre projet

:position 30,30,40,40

:overlay

### Fenêtre projet

La fenêtre projet s'ouvre lorsque vous créez un nouveau projet ou ouvrez
l'un de vos projets existants. C'est ici que vous programmez, testez, créez
des sprites, des maps et règlez tous les détails de votre projet.

## Navigation

### Navigation dans le projet

Une colonne d'icônes est située à gauche de l'écran. Elle vous permet d'accéder rapidement
à l'éditeur de code, de sprites, de maps, de documentation, aux paramètres et aux options
de publication de votre projet.

:highlight #projectview .sidemenu ul



## Section Code

### Code et exécution

Cliquez sur **Code** pour accéder à la première section.

:highlight #projectview .sidemenu #menuitem-code

:auto



## Section Code 2

:navigate projects.code

### Code et exécution

C'est ici que vous pourrez programmer, exécuter votre application et la débugguer.
La partie gauche de l'écran est l'éditeur de code, où vous taperez votre programme.
La partie droite comporte en haut la fenêtre d'exécution et en bas la console, qui
vous permet d'envoyer des commandes, de faire des vérifications et modifications
de variables en temps réel.


## Section Sprites

### Sprites

Cliquez sur **Sprites** pour accéder à l'éditeur de sprites.

:highlight #projectview .sidemenu #menuitem-sprites

:auto

## Section Sprites 2

:navigate projects.sprites

### Sprites

Vous vous trouvez ici dans l'éditeur de sprites. Les sprites sont des images que
vous pouvez dessiner ici puis utiliser dans votre programme. Cliquez sur un sprite
dans la liste de gauche pour l'ouvrir, puis utilisez les fonctions de dessin à droite
pour dessiner.


## Section Maps

### Maps

Cliquez sur **Maps** pour accéder à l'éditeur de maps.

:highlight #projectview .sidemenu #menuitem-maps

:auto

## Section Maps 2

:navigate projects.maps

### Maps

Voici l'éditeur de map. Map est le nom anglais pour "carte". Les maps sont souvent
utilisées pour créer un niveau de jeu vidéo ou un environnement complet à explorer.
Elles sont créées en assemblant sur une grille des sprites choisis parmi ceux de votre
projet.


## Section Doc

### Doc

Cliquez sur **Doc** pour accéder à l'éditeur de doc.

:highlight #projectview .sidemenu #menuitem-doc

:auto

## Section Doc 2

:navigate projects.doc

### Doc

Voici l'éditeur de doc ("documentation"). Si votre projet est un plug-in intégrable
par d'autres, ou une démo qui nécessite des explications, vous pouvez rédiger ici
une documentation en utilisant le langage markdown. Les tutoriels microStudio sont
eux-même créés avec cet éditeur !



## Section Paramètres

### Paramètres

Cliquez sur **Paramètres** pour accéder aux paramètres.

:highlight #projectview .sidemenu #menuitem-options

:auto

## Section Paramètres 2

:navigate projects.options

### Paramètres

Vous pouvez ici modifier le titre et l'URL de votre projet. Vous pouvez aussi modifier
le mot secret utilisé pour garder votre projet privé tout en vous permettant de le tester.
Vous pourrez définir l'orientation de l'écran idéale pour votre projet. Enfin vous pouvez
inviter vos amis à venir contribuer à votre projet. Il suffit pour cela de
connaître leur pseudo microStudio.


## Section Publier

### Publier

Cliquez sur **Publier** pour accéder à la zone de publication.

:highlight #projectview .sidemenu #menuitem-publish

:auto

## Section Publier 2

:navigate projects.publish

### Publier

Lorsque votre projet est terminé, vous pouvez le rendre disponible publiquement pour
tous les utilisateurs microStudio. Vous pouvez aussi le garder pour vous et l'exporter
en HTML5, ce qui vous permettra de le publier sur votre propre site web ou sur une plateforme
de publication de jeux.



## Fin

Ce tutoriel est terminé. Vous pouvez maintenant lancer le tutoriel "Premier projet" pour
commencer à créer une application avec microStudio.
