# Урок

:project Урок: Первый проект

## Первый проект

:position 30,30,40,40

:overlay

### Первый проект

Ваш первый проект уже создан! Вы создадите персонажа и запрограммируете microStudio для отображения его на экране и обеспечения возможности его перемещения по экрану с помощью клавиш со стрелками на клавиатуре вашего компьютера.


## Создание спрайта

### Создание спрайта

Нажмите **Спрайты**, чтобы открыть редактор спрайтов.

:highlight #projectview .sidemenu #menuitem-sprites

:auto

## Создание спрайта 2

### Создание спрайта

Нажмите кнопку " Добавить спрайт", чтобы создать новый спрайт.

:navigate projects.sprites

:highlight #create-sprite-button

:auto


## Нарисуйте свой спрайт

:navigate projects.sprites

:position 0,50,30,40

### Нарисуйте своего персонажа

Используйте инструменты рисования в правой части экрана, чтобы нарисовать своего персонажа.
Вы можете потратить на это столько времени, сколько захотите!

Когда ваш спрайт будет готов, переходите к следующему шагу.

## Код 1

### Код

Теперь нажмите **Код**, мы собираемся немного заняться программированием!

:highlight #projectview .sidemenu #menuitem-code

:auto


## Код

:navigate projects.code

:position 55,30,45,40

### Код

Код вашего проекта уже заполнен определением трех функций:
``init``, ``update`` и ``draw``. Мы будем работать над содержимым функции ``draw``. Добавьте следующую строку между строками ``draw = function()`` и строкой ``end``:

```
  screen.drawSprite("sprite", 0, 0, 20)
```

Вот как теперь выглядит ваш код:

```
draw = function()
  screen.drawSprite("sprite", 0, 0, 20)
end
```

## Запуск

:navigate projects.code

:position 55,55,45,40

### Запустите вашу программу

Давайте попробуем! Нажмите кнопку Начать, чтобы запустить вашу программу.

:highlight #run-button

:auto

## Запуск

:navigate projects.code

:position 55,55,45,40

### Выполнение

Теперь ваш символ отображается в центре окна выполнения. Строка кода
которую мы добавили, вызывает функцию ``drawSprite`` на объекте
``screen``. Вызов осуществляется с параметрами: имя спрайта для отображения ``"sprite"`` (убедитесь, что это действительно имя созданного вами спрайта), x и y координаты точки где он будет отображаться (0, 0 - это центр экрана) и размер отображения (20).

Вы можете поиграть с этими координатами, чтобы изменить положение рисования спрайта. Вы заметите что ваши изменения отражаются в реальном времени в окне выполнения.

## Добавляем фон

:navigate projects.code

### Добавляем цвет фона

Над нашей строкой ``screen.drawSprite(...)`` мы добавим следующую строку:

```
  screen.fillRect(0, 0, 400, 400, "#468")
```

``fillRect`` означает "заполнить прямоугольник". Параметр ``"#468"`` представляет собой сине-серый цвет. Щелкните на нем, а затем нажмите и удерживайте клавишу CTRL, появится окно выбора цвета. Выберите цвет, который вам больше всего нравится!


## Управление персонажем

:navigate projects.code

### Управление персонажем

Для того чтобы управлять положением рисования персонажа, мы будем использовать две переменные, ``x`` и ``y``.
Давайте изменим строку кода, которая рисует спрайт, следующим образом:

```
  screen.drawSprite("sprite", x, y, 20)
```

Теперь персонаж будет нарисован в координатах ``x``, ``y``.

## Управление персонажем 2

:navigate projects.code

### Управление персонажем

Все, что нам теперь нужно, это изменять значения ``x`` и ``y`` при нажатии клавиш  со стрелками. Вставьте следующую строку между ``update = function()`` и ``end``:

```
  if keyboard.LEFT then x = x-1 end
```

Теперь ваш полный код выглядит следующим образом:

```
init = function()
end

update = function()
  if keyboard.LEFT then x = x-1 end
end

draw = function()
  screen.fillRect(0, 0, 400, 400, "rgb(140,198,110)")
  screen.drawSprite("sprite", x, y, 20)
end
```

## Управление персонажем

:navigate projects.code

### Управление персонажем

Щелкните на окне выполнения, затем нажмите клавишу со стрелкой влево на клавиатуре вашего компьютера.
Вы должны увидеть, что персонаж движется влево!

Почему: добавленная нами строка кода проверяет, нажата ли клавиша со стрелкой влево (``keyboard.LEFT``) и если это так, то значение ``x`` уменьшается на 1.

Зная, что другими идентификаторами клавиш со стрелками являются RIGHT, UP и DOWN, добавьте в код три строки чтобы ваш персонаж мог двигаться в любом направлении.

(Решение в следующем шаге)

## Управление персонажем

:navigate projects.code

### Управление персонажем

Вот полный код функции ``update`` для перемещения персонажа во всех 4х направлениях с помощью стрелок клавиатуры:

```
update = function()
  if keyboard.LEFT then x = x-1 end
  if keyboard.RIGHT then x = x+1 end
  if keyboard.UP then y = y+1 end
  if keyboard.DOWN then y = y-1 end
end
```

## Конец

Этот урок закончен. Теперь вы можете узнать больше о программировании на *microScript*,  начав курс по программированию.